'
'THIS VERSION USES SYNC FROM THE PROP SIDE
'
'SPECTRUM OUTPUT


   
         ' the output from the propeller in this cog - demo graphics showing prop is an overlay
                        ' could also have P-I-Picture  by sednign  window(s) of data from the fpg 
 
 

CON
  _clkmode = xtal1 + pll16x
  _xinfreq = 5_000_000

  _leftChannelVolume = 32
  _rightChannelVolume = 32

  _baudRateSpeed = 115200 ' Teraterm does not work at this speed. Use hyperterminal or other programs
'  _newLineCharacter = 13
  _clearScreenCharacter = 16
  _homeCursorCharacter = 1

  _receiverPin = 31
  _transmitterPin = 30
  
  _TV_Pin = 12 ' group of 3 pins starting at pin 16

  _VGA_PinGroup = 2
                                                  
  MODE_VT100 = 0
  MODE_VGA = 1
  MODE_VGA2 = 2
  MODE_SPECTRUM = 3
  
  ' PHENIX PINS - Chameleon Shared SPI bus with PIC
  
  _SD_DO = 10   ' sensitive
  _SD_CLK = 11   '11    'sensitive
  _SD_DI = 9      'not so sensitive   DI = data in from the SD card perspective
  _SD_CS = 15
  _SD_WP = -1 ' -1 ifnot installed.
  _SD_CD = -1 ' -1 ifnot installed.
 
   
         
OBJ

  fpga_vga_out: "fpga_asm_vga_outCopier.spin"
 ' fpga_vga_out: "fpga_asm_vga_out.spin"
 ' key : "Pocketerm_Keyboard"           ' pocketerm keyboard
 
 ' delay: "Timing"                     ' for millisecond delays
   Freq : "SynthLynx"   
VAR
 long params[5]
 long vidmask8      
  
  'long sync    'long    0        ' ? should this be here or in VAR?      taken and put there to test
  'byte _VGA_Enabled ' VGA display on
  
  'cursor control bytes
 ' byte  cx0, cy0, cm0, cx1, cy1, cm1
 
  
               
PUB Open( setBasePin, setMode, ptrToPalette ) | h, i, j, k, x, y  ,bdir ,oldmode, xx, fred, mabel

    vidmask8 := %00001111   ' lower two bits are bit 1 horiz and bit 0 vert synch, rest are RGB pairs
  '  vidmask8 := $ff   ' lower two bits are bit 1 horiz and bit 0 vert synch, rest are RGB pairs
      
    'Setup Pins
    DIRA[15] := 1            ' ps2 keyboard  (and also SD_clock - however the other lines (hopefully) are unchanging during its dual role and the SD card is unaffected
    DIRA[25] := 1
    
    DIRA[9] := 0
    DIRA[10] := 0            ' SPI LINES    - SD clock is on PIN 15
    DIRA[11] := 0             ' ?do these go to the fpga any more?
    
     DIRA[7..0] := 0               ' FPGA 8 bit BUS PINS

     DIRA[23..16] := 1          ' VGA OUTPUT PINS

    'key.start(26,27)

  
  '   Freq.Synth("A",15, VGA_Clock_Frequency )  test - was used for driving fpga video (to synch up)
  
              
    ' Wait for TV to start up properly otherwise get pixels out of synch address  
     waitcnt(clkfreq+cnt)      
     
     fpga_vga_out.Open(vidmask8,@params)   ' start cog which copies screen memory from FPGA 
    ' _VGA_Enabled := true
 '   waitcnt(clkfreq+cnt)        ' wait a second

    ' This cog stays running
    ' and
    '
    
    ' Copies the PS/2 keyboard lines (one way only) from the keyb (linked to the propeller) over onto
    ' two pins set up as inputs on the fpga side
    ' spin seems to be just fast enough to do this and the lack
    ' of receiving means lock commands can get out of synch / leds wont change etc.
    'waitcnt((clkfreq *2)+ cnt ) ' wait 2 secs


  '  fpga_vga_out.Close 


    ' Now Upload the ROM to the fpga
    '

    
    
  '  waitcnt((clkfreq *2)+ cnt )
 ' fpga_vga_out.Open($ff,@params)   ' start cog which copies screen memory from FPGA 
      '
   repeat
  
       OUTA[25] :=  INA[26]
       OUTA[15] :=  INA[27] 

 '      if key.gotkey <>0         ' scan both the local keyboard and the com port
  '         result:=key.getkey
   '         if result == 219   'F12 key
    '          if _VGA_Enabled == false
     '                           fpga_vga_out.Open(vidmask8,@params)  
      '                          _VGA_Enabled := true
       '       
        '      else
         '                       fpga_vga_out.Close
          '                      _VGA_Enabled := false
                                         
 

   

PUB Close

 
 '   fpga.Close




DAT 
Str byte "This is a data string.", 0 
Data file "lynx48-1.rom"      

  
 'just got here was about to put a spectrunm rom in 16k  here
 
 
' FOR SPECTRUM OUTPUT - HOLDS THE SCREEN MEMORY 
'pixels   byte 4800 * 4  '               file    "JetPacRaw.scr"      'memory for screen taken up here 8192? bytes

'pixels    file    "JetPacRaw.scr"      'memory for screen taken up here 8192? bytes
'pixels2    file    "JetPacRaw.scr"      'memory for screen taken up here 8192? bytes
'pixels3    file    "JetPacRaw.scr"      'memory for screen taken up here 8192? bytes


 'VGA OUTPUT VARIABLES
' pixels long 4800 * 4
'pixels  long 8400 * 4
' colors word  tiles